/* ====================================================================
 * Copyright (c) 1995-1999 The Apache Group.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the Apache Group
 *    for use in the Apache HTTP server project (http://www.apache.org/)."
 *
 * 4. The names "Apache Server" and "Apache Group" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the Apache Group
 *    for use in the Apache HTTP server project (http://www.apache.org/)."
 *
 * THIS SOFTWARE IS PROVIDED BY THE APACHE GROUP ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE APACHE GROUP OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Group and was originally based
 * on public domain software written at the National Center for
 * Supercomputing Applications, University of Illinois, Urbana-Champaign.
 * For more information on the Apache Group and the Apache HTTP server
 * project, please see <http://www.apache.org/>.
 *
 */

/* 
 * Info Module.  Display configuration information for the server and
 * all included modules.
 *
 * <Location /online>
 * SetHandler radwho
 * </Location>
 *
 * GET /online - Returns who is currently online
 * GET /online?server - Returns server configuration only
 * GET /online?module_name - Returns configuration for a single module
 * GET /online?list - Returns quick list of included modules
 *
 * Robert 'Admiral' Coeyman <admiral@corner.net> 2001
 *
 * Built from the mod_info file.
 *
 */

/* #include "httpd.h"
 * #include "http_config.h"
 * #include "http_core.h"
 * #include "http_log.h"
 * #include "http_main.h"
 * #include "http_protocol.h"
 * #include "util_script.h"
 * #include "http_conf_globals.h"
 */
#include <stdio.h>
#include <time.h>
#include <mysql/mysql.h>


typedef struct sql_socket {
	MYSQL *sock;
	MYSQL conn;
	int id;
	int in_use;
/*	struct timeval tv;       */
} SQLSOCK;

#define NULL ((void *)0)



/* module icradius_who_module; */


int main(void)
{
    SQLSOCK *socket;
    MYSQL_ROW row;	
    MYSQL_RES *result;
    char buf[256];
    int iii,comma = 0;
    struct tm *btime;
    time_t now, then, online;	

    puts("<html><head><title>Radius Information</title></head>\n");
    puts("<body><h1 align=center>Icradius Login Information</h1>\n");

socket=(SQLSOCK *)malloc(sizeof(SQLSOCK));  /* create the socket */

if ( socket == NULL ) {
	puts("SERIOUS problem. Socket got no memory.\n");
	return 0;
}
puts ("Socket created\n");
mysql_init(&(socket->conn));       /* Activate the socket         */
puts("Socket Initialized");
socket->sock = mysql_real_connect(&(socket->conn),"localhost","operator",
"BlueBird69","radius",0,NULL,0);

if (socket->sock == NULL ) {
	puts("<B>Failed to connect to the radius server</B>");
	printf("<BR>Error:%s<BR></BODY></HTML>\n",
	mysql_error(socket->sock));
	mysql_free_result(result);
	mysql_close(socket->sock);
	free(socket);
	return 0;
}
puts("Socket Connected");

sprintf((char *)&buf,"SELECT UserName,NASPortId,AcctStartTime,FramedIPAddress,UNIX_TIMESTAMP(AcctStartTime) FROM radacct
WHERE AcctSessionTime = '0'");
if (socket->sock == NULL ) {
	puts("<B>Failed to QUERY the radius server</B>");
	printf("<BR>Error:%s<BR></BODY></HTML>\n",
	mysql_error(socket->sock));
	mysql_free_result(result);
	mysql_close(socket->sock);
	free(socket);
	return 0;
}
now = time(NULL);
mysql_query(socket->sock,(char *)&buf);
puts("Ran Query");
result=mysql_store_result(socket->sock);
comma=mysql_field_count(socket->sock);
puts("Stored result");
printf("Stored %d fields",comma);
if (result == NULL ) {
	puts("<B>Failed to STORE the query result.</B>");
	printf("<BR>Error:%s<BR></BODY></HTML>\n",
	mysql_error(socket->sock));
	mysql_free_result(result);
	mysql_close(socket->sock);
	free(socket);
	return 0;
}

comma = mysql_num_rows(result);
puts("--Got row count.\n");
printf("%d rows.",comma);

if ( comma == 0 ) {
	puts("<B>No users found online at this time</B>\n");
	puts("</BODY></HTML>\n");
	mysql_free_result(result);
	mysql_close(socket->sock);
	free(socket);
	return 0;
}

printf("<CENTER><H1>%d Users online</H1></CENTER><BR>",comma);
puts("<TABLE WIDTH=100\% BORDERWIDTH=1>\n");
  
/* Start with a header */

	puts("<TR>\n");
	puts("<TR><TH>UserName</TH>\n");
	puts("<TR><TH>Port</TH>\n");
	puts("<TR><TH>Login Time</TH>\n");
	puts("<TR><TH>User IP</TH>\n");
	puts("<TR><TH>Online</TH>\n");
	puts("</TR>\n");

/* Then print all the data from a loop */

puts("Preparing to fetch rows.");
for ( iii=0;iii<comma;iii++) {
	row = mysql_fetch_row(result);
        then = (time_t)atol(row[4]);
	online = now - then;
/* Convert the time online for printing.  */
	btime = gmtime((time_t *)&online);
	puts("<TR>\n");
	printf("<TD>%s</TD>\n",row[0]);
	printf("<TD>%s</TD>\n",row[1]);
	printf("<TD>%s</TD>\n",row[2]);
	printf("<TD>%s</TD>\n",row[3]);
	printf("<TD>%dH %dM %dS</TD>\n",btime->tm_hour,
		btime->tm_min,btime->tm_sec);;
	puts("</TR>\n");
}

/* Now finish up the table */
	puts("\n<TR>\n");                  /* repeat the header */
	puts("<TR><TH>UserName</TH>\n");
	puts("<TR><TH>Port</TH>\n");
	puts("<TR><TH>Login Time</TH>\n");
	puts("<TR><TH>User IP</TH>\n");
	puts("<TR><TH>Online</TH>\n");
	puts("\n</TR>\n");
	puts("</TABLE><BR><BR><BR>\n");  /* close the table */

/* Close out my socket  */
	mysql_free_result(result);
	mysql_close(socket->sock);
	free(socket);
/*    ap_rputs(ap_psignature("",r), r);   */
    puts("</body></html>\n");
    /* Done, turn off timeout, close file and return */
/*    ap_kill_timeout(r);                 */
    return 0;
}
